/*----- PROTECTED REGION ID(Test.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        Test.cpp
//
// description : C++ source for the Test class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               Test are implemented in this file.
//
// project :
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <Test.h>
#include <TestClass.h>

/*----- PROTECTED REGION END -----*/	//	Test.cpp

/**
 *  Test class description:
 *
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//================================================================
//  State         |  Inherited (no method)
//  Status        |  Inherited (no method)
//  GenerateData  |  generate_data
//================================================================

//================================================================
//  Attributes managed is:
//================================================================
//  data  |  Tango::DevDouble	Scalar
//================================================================

namespace Test_ns
{
/*----- PROTECTED REGION ID(Test::namespace_starting) ENABLED START -----*/

//	static initializations

/*----- PROTECTED REGION END -----*/	//	Test::namespace_starting

//--------------------------------------------------------
/**
 *	Method      : Test::Test()
 *	Description : Constructors for a Tango device
 *                implementing the classTest
 */
//--------------------------------------------------------
Test::Test(Tango::DeviceClass *cl, string &s)
 : TANGO_BASE_CLASS(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(Test::constructor_1) ENABLED START -----*/
	init_device();

	/*----- PROTECTED REGION END -----*/	//	Test::constructor_1
}
//--------------------------------------------------------
Test::Test(Tango::DeviceClass *cl, const char *s)
 : TANGO_BASE_CLASS(cl, s)
{
	/*----- PROTECTED REGION ID(Test::constructor_2) ENABLED START -----*/
	init_device();

	/*----- PROTECTED REGION END -----*/	//	Test::constructor_2
}
//--------------------------------------------------------
Test::Test(Tango::DeviceClass *cl, const char *s, const char *d)
 : TANGO_BASE_CLASS(cl, s, d)
{
	/*----- PROTECTED REGION ID(Test::constructor_3) ENABLED START -----*/
	init_device();

	/*----- PROTECTED REGION END -----*/	//	Test::constructor_3
}

//--------------------------------------------------------
/**
 *	Method      : Test::delete_device()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void Test::delete_device()
{
	DEBUG_STREAM << "Test::delete_device() " << device_name << endl;
	/*----- PROTECTED REGION ID(Test::delete_device) ENABLED START -----*/

	//	Delete device allocated objects

	/*----- PROTECTED REGION END -----*/	//	Test::delete_device
	delete[] attr_data_read;
}

//--------------------------------------------------------
/**
 *	Method      : Test::init_device()
 *	Description : will be called at device initialization.
 */
//--------------------------------------------------------
void Test::init_device()
{
	DEBUG_STREAM << "Test::init_device() create device " << device_name << endl;
	/*----- PROTECTED REGION ID(Test::init_device_before) ENABLED START -----*/

	//	Initialization before get_device_property() call

	/*----- PROTECTED REGION END -----*/	//	Test::init_device_before

	//	No device property to be read from database

	attr_data_read = new Tango::DevDouble[1];
	/*----- PROTECTED REGION ID(Test::init_device) ENABLED START -----*/
  *attr_data_read = 0;
	//	Initialize device

	/*----- PROTECTED REGION END -----*/	//	Test::init_device
}


//--------------------------------------------------------
/**
 *	Method      : Test::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void Test::always_executed_hook()
{
	DEBUG_STREAM << "Test::always_executed_hook()  " << device_name << endl;
	/*----- PROTECTED REGION ID(Test::always_executed_hook) ENABLED START -----*/

	//	code always executed before all requests

	/*----- PROTECTED REGION END -----*/	//	Test::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method      : Test::read_attr_hardware()
 *	Description : Hardware acquisition for attributes
 */
//--------------------------------------------------------
void Test::read_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "Test::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(Test::read_attr_hardware) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	Test::read_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute data related method
 *	Description:
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Test::read_data(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Test::read_data(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Test::read_data) ENABLED START -----*/
	//	Set the attribute value
	attr.set_value(attr_data_read);

	/*----- PROTECTED REGION END -----*/	//	Test::read_data
}

//--------------------------------------------------------
/**
 *	Method      : Test::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void Test::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(Test::add_dynamic_attributes) ENABLED START -----*/

	//	Add your own code to create and add dynamic attributes if any

	/*----- PROTECTED REGION END -----*/	//	Test::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Command GenerateData related method
 *	Description:
 *
 */
//--------------------------------------------------------
void Test::generate_data()
{
	DEBUG_STREAM << "Test::GenerateData()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Test::generate_data) ENABLED START -----*/

  *attr_data_read += 1;
  push_data_ready_event("data", *attr_data_read);

	/*----- PROTECTED REGION END -----*/	//	Test::generate_data
}
//--------------------------------------------------------
/**
 *	Method      : Test::add_dynamic_commands()
 *	Description : Create the dynamic commands if any
 *                for specified device.
 */
//--------------------------------------------------------
void Test::add_dynamic_commands()
{
	/*----- PROTECTED REGION ID(Test::add_dynamic_commands) ENABLED START -----*/

	//	Add your own code to create and add dynamic commands if any

	/*----- PROTECTED REGION END -----*/	//	Test::add_dynamic_commands
}

/*----- PROTECTED REGION ID(Test::namespace_ending) ENABLED START -----*/

//	Additional Methods
// //--------------------------------------------------------
// /**
//  *	Command WriteBool related method
//  *	Description:
//  *
//  *	@param argin
//  */
// //--------------------------------------------------------
// void Test::write_bool(Tango::DevBoolean argin)
// {
// 	DEBUG_STREAM << "Test::WriteBool()  - " << device_name << endl;
// 	*attr_AccessBool_read = argin;
// }

// //--------------------------------------------------------
// /**
//  *	Read attribute AccessBool related method
//  *	Description:
//  *
//  *	Data type:	Tango::DevBoolean
//  *	Attr type:	Scalar
//  */
// //--------------------------------------------------------
// void Test::read_AccessBool(Tango::Attribute &attr)
// {
// 	DEBUG_STREAM << "Test::read_AccessBool(Tango::Attribute &attr) entering... " << endl;
// 	//	Set the attribute value
// 	attr.set_value(attr_AccessBool_read);
// }

// //--------------------------------------------------------
// /**
//  *	Write attribute AccessBool related method
//  *	Description:
//  *
//  *	Data type:	Tango::DevBoolean
//  *	Attr type:	Scalar
//  */
// //--------------------------------------------------------
// void Test::write_AccessBool(Tango::WAttribute &attr)
// {
// 	DEBUG_STREAM << "Test::write_AccessBool(Tango::WAttribute &attr) entering... " << endl;
// 	//	Retrieve write value
// 	Tango::DevBoolean	w_val;
// 	attr.get_write_value(w_val);
// }


/*----- PROTECTED REGION END -----*/	//	Test::namespace_ending
} //	namespace
