/*----- PROTECTED REGION ID(TestClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        TestClass.h
//
// description : Include for the Test root class.
//               This class is the singleton class for
//                the Test device class.
//               It contains all properties and methods which the 
//               Test requires only once e.g. the commands.
//
// project :     
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef TestClass_H
#define TestClass_H

#include <tango.h>
#include <Test.h>


/*----- PROTECTED REGION END -----*/	//	TestClass.h


namespace Test_ns
{
/*----- PROTECTED REGION ID(TestClass::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	TestClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute data class definition
class dataAttrib: public Tango::Attr
{
public:
	dataAttrib():Attr("data",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~dataAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Test *>(dev))->read_data(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Test *>(dev))->is_data_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command GenerateData class definition
class GenerateDataClass : public Tango::Command
{
public:
	GenerateDataClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GenerateDataClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GenerateDataClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Test *>(dev))->is_GenerateData_allowed(any);}
};


/**
 *	The TestClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  TestClass : public Tango::DeviceClass
#else
class TestClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(TestClass::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	TestClass::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static TestClass *init(const char *);
		static TestClass *instance();
		~TestClass();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		TestClass(string &);
		static TestClass *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	Test_H
