#include <tango.h>

class CallBack : public Tango::CallBack
{
  public:
  virtual void push_event(Tango::DataReadyEventData *e) override
  {
    if(e->err)
    {
      Tango::Except::print_error_stack(e->errors);
      return;
    }

    Tango::DeviceAttribute da = e->device->read_attribute("data");
    double data;
    da >> data;

    printf("DRE: value: %05g, counter: %05d\n", data, e->ctr);
  }
};

int main(int argc, char **argv)
{
  CallBack cb;

  try
  {
    auto *device = new Tango::DeviceProxy("Test/ts/1");

    device->ping();

    device->subscribe_event("data", Tango::DATA_READY_EVENT, &cb, false);

    for(int i = 0; i < 1000; i += 1)
    {
      device->command_inout("GenerateData");
    }
  }
  catch(Tango::DevFailed &e)
  {
    Tango::Except::print_exception(e);
    exit(1);
  }

  sleep(5);

  return 0;
}
